<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Bootstrap Flex</title>
		<title></title>
		<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
</head>
<body>
	<h1 class="text-center my-5">Bootstrap Flex</h1>
	<!-- 
		Flexbox is used to manipulate and layout the elements. This can be done in CSS. However, in Bootstrap, it is easier and faster to implement flex because all the developer has to do is to ad the class d-flex to the parent of the flex item.

		When adding d-flex to the parent, the items become inline, in a row, and can be modified i.e. manipulating the h and w;


		Flex Directions (flex-direction) - can change the directions of the flex items; by default, flex-row is the arrangement of the flex items.
		
		Flex Row (flex-row) - start the items from the left side (default)

		Flex Row Reverse (flex-row-reverse) - starts the items from the right side and reverses the order of the flex items.

		Flex Column (flex-column) - arranges the items from top to bottom; the items will occupy the width of the parent (default)
		
		Flex Column Reverse (flex-column-reverse) - same as the flex column but the arrangements starts from bottom to top

	 -->
	 <h3 class="text-center my-3">Flex Row</h3>

	<div class="bg-dark d-flex mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="bg-dark d-flex mb-4">
		<span class="bg-primary p-2">SpanFlex1</span>
		<span class="bg-danger p-2">SpanFlex2</span>
		<span class="bg-success p-2">SpanFlex3</span>
	</div>


	<h3 class="text-center my-5">Flex Row Reverse</h3>
	<div class="d-flex flex-row-reverse bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Flex Column</h3>
		<div class="d-flex flex-column bg-dark mb-4 p-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-danger p-2">Flex Item 2</div>
			<div class="bg-success p-2">Flex Item 3</div>
		</div>
		<div class="bg-dark d-flex flex-column mb-4 p-4">
			<span class="bg-primary p-2">SpanFlex1</span>
			<span class="bg-danger p-2">SpanFlex2</span>
			<span class="bg-success p-2">SpanFlex3</span>
		</div>

	<h3 class="text-center my-5">Flex Column Reverse</h3>
		<div class="bg-dark d-flex flex-column-reverse mb-4 p-4">
				<div class="bg-primary p-2">Flex Item 1</div>
				<div class="bg-danger p-2">Flex Item 2</div>
				<div class="bg-success p-2">Flex Item 3</div>
		</div>

<!-- Justified Content -->
	<h2 class="text-center my-5">Justify Content</h2>
	<!-- 
		Justify Content - manipualtes and changes the alignment of the flex=row items along the main axis. The main axis for flex-row  items is the x axis; allows horizontally align the flex-row items 
	-->
	<h3 class="text-center my-5">Justify Content</h3>
	<div class="bg-dark d-flex flex-row justify-content-start mb-4">
	<!-- justify-content-start is the default value for flex items; it allows the flex itemsto the start of their main axis. flex-row:left::flex-row-reverse:right -->
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-start mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<h3 class="text-center my-5">Justify Content</h3>
	<div class="bg-dark d-flex flex-row justify-content-end mb-4">
	<!-- justify-content-end - it aligns the flex items where their main axis ends. flex-row:right :: flex-row-reverse:left -->
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-end mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Justify Content Center</h3>
	<div class="bg-dark d-flex flex-row justify-content-center mb-4">
	<!-- justify-content-end - it aligns the flex items at the center of their main axis. flex-row:center :: flex-row-reverse:center -->
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<h3 class="text-center my-5">Justify Content Between</h3>
	<div class="bg-dark d-flex flex-row justify-content-between mb-4">
	<!-- justify-content-between distributes remaining spaces in between the items -->
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-between mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>
	<h3 class="text-center my-5">Justify Content Around</h3>
	<div class="bg-dark d-flex flex-row justify-content-around mb-4">
	<!-- justify-content-around distributes remaining spaces around the items (there are spaces on the left and the right of each items) -->
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-around mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>

<!-- Align Items -->

	<h2 class="text-center my-5">Align Items</h2>
	<div class="bg-dark d-flex flex-row align-items-start mb-4" style="height: 50vh;">
<!-- align-items-start - aligns flex-row and flex-row-reverse items at the start of the y axis;
			flex row and flex row reverse have y axis as the cross axis and the x axis is the main axis
			flex column and flex column reverse have y axis as the main axis and x axis as the cross axis

			flex row and flex row reverse start at the top of the y axis -->
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse align-items-start mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>

	<h2 class="text-center my-5">Align Items End</h2>
	<!-- align-items-end - aligns items flex-row and flex-row-reverse at the end of the y axis -->
	<div class="bg-dark d-flex flex-row align-items-end mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse align-items-end mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>
	<h2 class="text-center my-5">Align Items Center</h2>
	<!-- align-items-center - aligns flex-row and flex-row-reverse items at the center of the y axis -->
	<div class="bg-dark d-flex flex-row align-items-center mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse align-items-center mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>

	<h2 class="text-center my-5">Aligning Vertically and Horizontally</h2>
	<div class="d-flex flex-row align-items-end justify-content-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>

	<div class="d-flex flex-row align-items-end justify-content-around bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>

	<div class="d-flex flex-row align-items-center justify-content-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>

<!-- Mini Activity -->
	<h3 class="text-center mb-5">Mini-Activity with Flex Row</h3>
	<div class="d-flex flex-row align-items-center justify-content-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>

	<div class="d-flex flex-row align-items-center justify-content-between bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>

	<h2 class="text-center mb-5">Flex Column with Align Items and Justify Content</h2>
	<div class="d-flex flex-column align-items-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:30%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:30%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:30%;">Flex Item 3</div>
		<div class="bg-warning p-2" style="width:30%;">Flex Item 4</div>
		<div class="bg-info p-2" style="width:30%;">Flex Item 5</div>
	</div>
	<div class="d-flex flex-column justify-content-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
		<div class="bg-warning p-2" style="width:20%;">Flex Item 4</div>
		<div class="bg-info p-2" style="width:20%;">Flex Item 5</div>
	</div>
<!-- 
	Flex row/row reverse - align items: vertically; justify content: horizontally
	Flex column/column reverse - align items: horizontally; justify content: vertically
 -->

 <!-- Mini Activity -->

	<h3 class="text-center my-5">Mini Activity with Flex Column</h3>
		<div class="d-flex flex-column justify-content-end bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
			<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
			<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
			<div class="bg-warning p-2" style="width:20%;">Flex Item 4</div>
			<div class="bg-info p-2" style="width:20%;">Flex Item 5</div>
		</div>
		<div class="d-flex flex-column align-items-end bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
			<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
			<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
			<div class="bg-warning p-2" style="width:20%;">Flex Item 4</div>
			<div class="bg-info p-2" style="width:20%;">Flex Item 5</div>
		</div>
	<h3 class="text-center my-5">Text Column with Justify Content Between and Around</h3>
		<div class="d-flex flex-column justify-content-between bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
			<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
			<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
			<div class="bg-warning p-2" style="width:20%;">Flex Item 4</div>
			<div class="bg-info p-2" style="width:20%;">Flex Item 5</div>
		</div>
		<div class="d-flex flex-column justify-content-around bg-dark mb-4" style="height:50vh;">
			<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
			<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
			<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
			<div class="bg-warning p-2" style="width:20%;">Flex Item 4</div>
			<div class="bg-info p-2" style="width:20%;">Flex Item 5</div>
		</div>

		
	<h3 class="text-center my-5">Flex Wrap</h3>
			<div class="d-flex flex-row justify-content-around flex-wrap bg-dark mb-4">
			<div class="bg-primary p-2">Flex Item 1</div>
			<div class="bg-primary p-2">Flex Item 2</div>
			<div class="bg-primary p-2">Flex Item 3</div>
			<div class="bg-primary p-2">Flex Item 4</div>
			<div class="bg-primary p-2">Flex Item 5</div>
			<div class="bg-primary p-2">Flex Item 6</div>
			<div class="bg-primary p-2">Flex Item 7</div>
			<div class="bg-primary p-2">Flex Item 8</div>
			<div class="bg-primary p-2">Flex Item 9</div>
		</div>



<!-- JS Dependencies -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>